<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.7                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2015                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/
class p_social extends cmsPlugin {

    
        public $config = array(
        'client_id'     => '',
        'client_secret' => '',
        'lang'          => 'ru'
    );

    public function __construct(){

        // Информация о плагине
        $this->info['plugin']      = 'p_social';
        $this->info['title']       = 'Авторизация через соцсети';
        $this->info['description'] = 'Авторизация напрямую через соцсети';
        $this->info['author']      = 'Lora & InstantCMS Team';
        $this->info['version']     = '1.10.7';

        // Настройки по-умолчанию
        $this->config['PL_PROVIDERS'] = 'facebook,google';
        $this->config['PL_LANG']      = 'ru';

        // События, которые будут отлавливаться плагином
        $this->events[] = 'SOCIAL_BUTTON';
        $this->events[] = 'SOCIAL_AUTH';
        $this->events[] = 'SOCIAL_GET';
        $this->events[] = 'SOCIAL_PAR';


      
        parent::__construct();

    }

// ==================================================================== //

    public function install(){

        $inDB = cmsDatabase::getInstance();

        if (!$inDB->isFieldExists('cms_users', 'socialid')){

            $inDB->query("ALTER TABLE `cms_users` ADD `socialid` VARCHAR( 250 ) NULL, ADD INDEX ( `socialid` )");

        }

        return parent::install();

    }

// ==================================================================== //


    public function upgrade(){

        cmsDatabase::getInstance()->query("UPDATE `cms_users` SET `socialid` = MD5(socialid) WHERE `socialid` IS NOT NULL");

        return parent::upgrade();

    }

// ==================================================================== //

    public function execute($event='', $item=array()){



        switch ($event){
            case 'SOCIAL_BUTTON':     $item = $this->showSocialButton(); break;
            case 'SOCIAL_GET'   :     $item = $this->SocialGet(); break;
        }

        return true;

    }

// ==================================================================== //
    private function showSocialButton() {

        global $_LANG;

        
        $url = 'https://www.facebook.com/dialog/oauth';


        $html  = '<div class="lf_title">'.$_LANG['PL_LOGIN_SOCIAL'].'</div>';
        
        $html .= '<a style="margin:15px 0" href =  '.$url . '?' .                                               urldecode(http_build_query($this->SocialPar($url))) . '><img height="40px" src="plugins/p_social/facebook.gif" /></a>';


        echo $html;
        
      
        return $this->SocialGet();

    }
// ==================================================================== //   

 public function SocialPar($url) {



$client_id = ''; 
$redirect_uri = ''; 

$params = array(
    'client_id'     => $client_id,
    'redirect_uri'  => $redirect_uri,
    'response_type' => 'code'
);

return $params;

}

// ==================================================================== //

private function SocialGet() {

 $url            = 'https://graph.facebook.com/oauth/access_token'; 
 
 $rederict_page  = "http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
 $rederict_page  = $this->deleteGET($rederict_page, "code");

if (isset($_GET['code'])) {
    $result = false;
   
    $params = array(
    'client_id'     => '', 
    'client_secret' => '', 
    'redirect_uri'  => $rederict_page, 
    'code'          => $_GET['code']
    );
 $tokenInfo = $this -> request($url,$params);

 
 
 if (count($tokenInfo) > 0 && isset($tokenInfo['access_token'])) {
        $params = array('access_token' => $tokenInfo['access_token']);
       

          $userInfo = json_decode(file_get_contents('https://graph.facebook.com/me' . '?' . 
        urldecode(http_build_query($params).'&fields=email,link,gender,picture,name,first_name,birthday')), true);    
}


        if (isset($userInfo['id'])) {
            $userInfo = $userInfo;
            $result = true;
        }
        

             
            if ($result) {
       $item=array();     
       $item['login']     =  current(explode('@',$userInfo['email']));
       $item['nickname']  = cmsCore::strClear($userInfo['name']);
       $item['email']     = $userInfo['email'];
       $item['birthdate'] = cmsCore::strClear($userInfo['birthday']);
       $item['gender']    = ($userInfo['gender'] == 'male') ? 'm' : 'f';
       $item['group_id']  = '1';
       $item['imageurl']  = 'http://graph.facebook.com/' . $userInfo['id'] . '/picture?type=large';
       $item['regdate']   = date('Y-m-d H:i:s');
       $item['logdate']   = date('Y-m-d H:i:s');
       $item['is_locked'] = '0';
       $item['is_logged_once'] = '1';
       
       $item['socialid']  =  md5($params['client_id']);       

       }
      
      $this->SocialAuth($item);

    return true;
    
    }
	else
	{
		return false;
		}
   

}

// ===================================================================== //

    private function request($url,$params) {

    if (function_exists('curl_init')){
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, urldecode(http_build_query($params)));
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    $result = curl_exec($curl);
    curl_close($curl);
    
    $tokenInfo = json_decode($result, true);
    }
    
    return $tokenInfo;
    }
    
// ===================================================================== //  
 
// =============================================================== //

  private function SocialAuth($item){
  
  $inDB   = cmsDatabase::getInstance();
  $inUser = cmsUser::getInstance();
  
  $user_id = $inDB->get_field('cms_users', "socialid='". $item['socialid']."'", 'id');
          if (!$user_id){
            $user_id = $this->createUser($item);
           
        }
        
        // если пользователь уже был или успешно создан, авторизуем
        if ($user_id){
			$user = $inDB->get_fields('cms_users', "id = '{$user_id}'", 'login, password');
			if(!$user) { cmsCore::error404(); }

			$back_url = $inUser->signInUser($user['login'], $user['password'], 1, 1);

			cmsCore::redirect($back_url);

        }

        // если авторизация не удалась, редиректим на сообщение об ошибке
       cmsCore::redirect('/auth/error.html');        
 
  }

// =================================================================== //

private function createUser($item){

        $inCore = cmsCore::getInstance();
        $inDB   = cmsDatabase::getInstance();
        $inUser = cmsUser::getInstance();
		cmsCore::loadClass('actions');

        $nickname = $email = $birthdate = '';
        
        // генерируем пароль
        $pass = md5(substr(md5(microtime().uniqid()), 0, 8));  
        
        if(!empty($item['email'])){

            $email = cmsCore::strClear($item['email']);

            $already_email = $inDB->get_field('cms_users', "email='{$email}' AND is_deleted=0", 'email');

            if ($already_email == $email){
                cmsCore::redirect('/auth/error.html');
            }

        }            

		// проверяем занятость логина
		$login = $item['login'];
		if ($inDB->get_field('cms_users', "login='{$login}' AND is_deleted=0", 'login') == $login){
			// если логин занят, добавляем к нему ID
			$max = $inDB->get_fields('cms_users', 'id>0', 'id', 'id DESC');
			$login .= ($max['id']+1);
		}
		
		$item['invited_by'] = 0;
		
            $user_array = cmsCore::callEvent('USER_BEFORE_REGISTER', array(
            'status'=>(!empty($item['status']) ? $item['status'] : ''),
            'status_date'=>date('Y-m-d H:i:s'),
            'login'=>$item['login'],
            'nickname'=>$item['nickname'],
            'password'=>$pass,
            'email'=>$item['email'],
            'birthdate'=>$item['birthdate'],
            'group_id'=>'1',
            'regdate'=>date('Y-m-d H:i:s'),
            'logdate'=>date('Y-m-d H:i:s'),
            'invited_by'=>0,
            'socialid'=> $item['socialid']
        ));
           $user_array['id'] = $user_id = $inDB->insert('cms_users', $user_array);
           
                      
                   $filename = 'nopic.jpg';
           
             if (!empty($item['imageurl'])){
                $photo_path = $this->downloadAvatar($item['imageurl']);
                if ($photo_path){
                    $uploaddir 		= PATH.'/images/users/avatars/';
                    $filename 		= md5($photo_path . '-' . $user_id . '-' . time()).'.jpg';
                    $uploadavatar 	= $uploaddir . $filename;
                    
                  file_put_contents($uploadavatar, file_get_contents($item['imageurl']));
                   
                    @unlink($photo_path);

                }
            }	
           
             $inUser->loadUserGeo();

            $inDB->insert('cms_user_profiles', array(
                'city'=>(!empty($item['city']) ? $item['city'] : $inUser->city),
                'user_id'=>$user_id,
                'imageurl'=>$filename,
                'gender'=>(!empty($item['gender']) ? strtolower($item['gender']) : 'm')
            ));

            cmsCore::callEvent('USER_REGISTER', $user_array);

			cmsActions::log('add_user', array(
				'object' => '',
				'user_id' => $user_id,
				'object_url' => '',
				'object_id' => $user_id,
				'target' => '',
				'target_url' => '',
				'target_id' => 0,
				'description' => ''
			));          
           
           return $user_id;	

}
// ==================================================================== //

    private function downloadAvatar($url){

        $tempfile   = PATH.'/images/users/avatars/'.md5(session_id()).'.jpg';

        if (function_exists('curl_init')){

            $curl = curl_init();

            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_HEADER, false);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_POST, false);
            $raw_data = curl_exec($curl);
            curl_close($curl);

        } else {

            $raw_data = file_get_contents($url);

        }

		if($f = @fopen($tempfile, 'w')){

			@fwrite($f, $raw_data);
			@fclose($f);

			return $tempfile;

		} else {

			return false;

		}

    }
// ===================================================================== //

  function deleteGET($rederict_page, $name, $amp = true) {
    $rederict_page = str_replace("&amp;", "&", $rederict_page);
    list($rederict_page_part, $qs_part) = array_pad(explode("?", $rederict_page), 2, ""); 
    parse_str($qs_part, $qs_vars); 
    unset($qs_vars[$name]); 
    if (count($qs_vars) > 0) { 
      $rederict_page = $rederict_page_part."?".http_build_query($qs_vars); 
      if ($amp) $rederict_page = str_replace("&", "&amp;", $rederict_page); 
    }
    else $rederict_page = $rederict_page_part;
    return $rederict_page; 
  }
  
// ======================================================================== //  

}